//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//


#pragma once

#include "IStdFile.h"

namespace VectorWorks
{
	namespace Filing
	{
		static const VWIID IID_ResourceFile = { 0x2FD48797, 0x9B44, 0x43B5, { 0x93, 0xA8, 0x11, 0xB7, 0x54, 0xAD, 0x1B, 0xD9 }};
		
		class DYNAMIC_ATTRIBUTE IResourceFile : public IVWUnknown
		{
		public:
			virtual VCOMError VCOM_CALLTYPE OpenRead(const TXString& fileSpecifier) = 0;
			virtual VCOMError VCOM_CALLTYPE Close() = 0;
			virtual VCOMError VCOM_CALLTYPE GetFileSize(Uint32& outSize) = 0;
			virtual VCOMError VCOM_CALLTYPE GetPosition(Uint32& outPosition) = 0;
			virtual VCOMError VCOM_CALLTYPE SetPosition(Uint32 position) = 0;
			virtual VCOMError VCOM_CALLTYPE SeekForward(Uint32 offset) = 0;
			virtual VCOMError VCOM_CALLTYPE SeekBackward(Uint32 offset) = 0;
			virtual VCOMError VCOM_CALLTYPE GetBytesLeft(Uint32& outBytesLeft) = 0;
			virtual VCOMError VCOM_CALLTYPE IsAtEndOfFile(bool& outIsEOF) = 0;
			virtual VCOMError VCOM_CALLTYPE Read(Uint32 bufferSize, Uint8* buffer) = 0;
			virtual VCOMError VCOM_CALLTYPE Read(Sint64& outValue) = 0;
			virtual VCOMError VCOM_CALLTYPE Read(Sint32& outValue) = 0;
			virtual VCOMError VCOM_CALLTYPE Read(Sint16& outValue) = 0;
			virtual VCOMError VCOM_CALLTYPE Read(Sint8& outValue) = 0;
			virtual VCOMError VCOM_CALLTYPE Read(TXString& outValue) = 0;
			virtual VCOMError VCOM_CALLTYPE ReadStringLine(TXString& outString) = 0;
			virtual VCOMError VCOM_CALLTYPE SetDefaultNewLine(ELineEndType type) = 0;
		};
		
		typedef VCOMPtr<IResourceFile>	IResourceFilePtr;
	}
}