//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//
//
//  This file contains the headers files needed for all GraphSoft Core functionality:
//		String Management
//		Debug Management (includes Exception handling)
//		Utilities (STL)
//

#ifndef _GS_CORE_
#define	_GS_CORE_

#pragma once

//  GSTypes.h contains all GraphSoft Core specific type definitions
#include "GSTypes.h"

#if !_MAGICFOLDER_
 // GSGeometry.h contains ViewRect, ViewPt, GSColor structures and the
 //	functions that are useful in manipulating them.
 #include "GSGeometry.h"
 
 //  GSUtil.h contains various GraphSoft utilities i.e. min, max, setmember..
 #include "GSUtil.h"
#endif

//  GSGlobals.h contains global #defines, global const declarations and global
//  variables that are necessary when using GSCore.h. Any #define, const or variable that
//	does not NEED a global scope should be placed elsewhere.  In addition if a const or
//	#def is associated closely with an object, the declaration should be placed
//	with the declaration of the object.
#include "GSGlobals.h"

//  The following includes are for all GraphSoft Core Objects and Core functionality.
#include "GSDebug.h"

//RWM Note: need to remove mac calls IU??? and remove the includes which include
//			Altura header files in order to include this in here.
//String #include "GSString.h"


#endif //_GS_CORE_