//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//


#if _MINICAD_
	// Inside VectorWorks, we need access to the full suite of types

	#include "StdHeaders.h"	// Must be first non-comment line.  See DMB.
	
	#include "MCMemory.h"
	
#else
	// As an external, the types are declared in RecordTypes.h, the Mac-specific types
	// come from MCTypes.h, and some of the code in this file does not even get built

	#ifdef _WINDOWS
	# include <Windows.h>
	# include <commctrl.h>
	# include <GSWinSDK.h>	// Graphsoft Required.
	#else
	# define	REAL_STL	1		// Use the standard template library.
	# ifdef _DEBUG
	#  include "GSBug.h"
	# else
	#include "GSRELEASE.h"
	# endif
	#endif

	// JAK 12/7/99 Changed from SharedDefines.h to CoreDefines.h to fix WIN lib compile error.
	// I guess RecordHandler.cpp needs altura when built into app but not when built into lib.
	#include "CoreDefines.h"	
	#include "GSCore.h"
	#include "GSString.h"
#endif

////////////////////////////////////////////////////////////////
// VW SDK
#include <MCCoordTypes.h>
#include <MiniCadHookIntf.h>
#include <GSESetup.h>
#include <MiniCadCallBacks.h>
#include <GSString.h>
#include <GSTypes.h>
#include <MCMatrix.h>

#include <RecordHandler.h>
#include <ExtendedProperties.h>

#include "VWFC/VWFCLibrary.h"

////////////////////////////////////////////////////////////////
// STL
#include <vector>
#include <map>

////////////////////////////////////////////////////////////////
// specific

#include "Interfaces/VectorWorks/IParasolidKernel.h"

