//
//	Copyright  Nemetschek Vectorworks, Inc.
//	Use of this file is governed by the Nemetschek Vectorworks SDK License Agreement
//	http://developer.vectorworks.net/index.php?title=Vectorworks_SDK_License
//

#include "StdHeaders.h"

#include "PictureCtrl.h"

#include "Dialog.h"

using namespace VWFC::VWUI;


VWPictureCtrl::VWPictureCtrl(TControlID id)
: VWControl( id )
{
}

VWPictureCtrl::~VWPictureCtrl()
{
}
#if T00809_IMAGE_RESOURCE_MANAGER_ENABLED
bool VWPictureCtrl::CreateControl(VWDialog* pDlg, const TXString& imageSpec)
{
	gSDK->CreateImageControl2(fpParentDlg->GetControlID(), fControlID, 0, 0, imageSpec);
	return VWControl::CreateControl( pDlg );
}

void VWPictureCtrl::SetImage(const TXString& imageSpec)
{
	gSDK->UpdateImageControl2(fpParentDlg->GetControlID(), fControlID, imageSpec);
}
#else
bool VWPictureCtrl::CreateControl(VWDialog* pDlg, long picID)
{
	::GS_CreateControl( gCBP, pDlg->GetControlID(), fControlID, kPictureControl, (unsigned char*)"", picID );
	return VWControl::CreateControl( pDlg );
}

void VWPictureCtrl::SetPictRSRCID(long picID)
{
	::GS_SetControlData( gCBP, fpParentDlg->GetControlID(), fControlID, picID );
}

void VWPictureCtrl::SetPictPNGID(long resPNG)
{
	gSDK->SetControlData( fpParentDlg->GetControlID(), fControlID, resPNG );
}
#endif

