#include "StdAfx.h"

#include "PluginResource.h"

#include "ExtObjTheLine.h"

using namespace Tester;

namespace Tester
{
	// --------------------------------------------------------------------------------------------------------
	static SToolDef		gToolDef = {
		/*ToolType*/					eExtensionToolType_Normal,
		/*ParametricName*/				"SampleToolDef_Line",
		/*PickAndUpdate*/				ToolDef::pickAndUpdate,
		/*NeedScreenPlane*/				ToolDef::doesntNeedScreenPlane,
		/*Need3DProjection*/			ToolDef::doesntNeed3DView,
		/*Use2DCursor*/					ToolDef::use2DCursor,
		/*ConstrainCursor*/				ToolDef::constrainCursor,
		/*NeedPerspective*/				ToolDef::doesntNeedPerspective,
		/*ShowScreenHints*/				ToolDef::showScreenHints,
		/*NeedsPlanarContext*/			ToolDef::needsPlanarContext,
		/*Reserved1*/					false,
		/*Reserved2*/					0,
		/*reserved 3*/					0,
		/*reserved 4*/					0, 
		/*Message*/						{11100, 4},
		/*WaitMoveDistance*/			0,
		/*ConstraintFlags*/				0,
		/*BarDisplay*/					kToolBarDisplay_XYClLaZo,
		/*MinimumCompatibleVersion*/	900,
		/*Title*/						{11100, 2},
		/*Category*/					{11100, 3},
		/*HelpText*/					{11100},
		/*VersionCreated*/				16,
		/*VersoinModified*/				0,
		/*VersoinRetired*/				0,
		/*contextual help*/				"",
		/*Icon Specifier*/				"DefaultTools/ExtObjTheLineDefTool.png",
		/*Cursor Specifier*/			"", 
	};

	// --------------------------------------------------------------------------------------------------------
	static SParametricDef gParametricDef = {
		/*LocalizedName*/			{11100, 1},
		/*SubType*/					kParametricSubType_Linear,
		/*ResetOnMove*/				false,
		/*ResetOnRotate*/			false,
		/*WallInsertOnEdge*/		false,
		/*WallInsertNoBreak*/		false,
		/*WallInsertHalfBreak*/		false,
		/*WallInsertHideCaps*/		false,
	};
	/*
	static SParametricParamChc	gArrChoices[] = {
		{ 128,	"Line",					{11002, 1} },
		{ 128,	"Arc",					{11002, 2} },
		{ 128,	"Bezier",				{11002, 3} },
		{ 128,	"None",					{11002, 4} },
		//------
		{ 129,	"Default Legend",		{11002, 5} },
		//------
		// TERMINATE
		{ NULL, NULL, {0,0} }
	};
	 */
	static SParametricParamDef gArrParameters[] = {
		{ "p1",			{11001, 1},		"False",	"False",	kFieldBoolean,		0 },
		{ "p2",			{11001, 2},		"False",	"False",	kFieldBoolean,		0 },
		{ "p3",			{11001, 3},		"",			"",			kFieldText,			0 },
		{ "p4",			{11001, 4},		"",			"",			kFieldText,			0 },
		{ "p5",			{11001, 5},		"2\"",		"2\"",		kFieldCoordDisp,	0 },
		{ "p6",			{11001, 6},		"Auto",		"Auto",		kFieldPopUp,		128 },
		{ "p7",			{11001, 7},		"Auto",		"Auto",		kFieldPopUp,		129 },
		// TERMINATE
		{ NULL, {0,0}, NULL, NULL, EFieldStyle(0), 0 }
	};
}


// --------------------------------------------------------------------------------------------------------
// {45C740D8-B0D5-43D7-A73B-391AB019CF85}
IMPLEMENT_VWExtension(
	/*Extension class*/	CExtObjTheLine,
	/*Event sink*/		CObjTheLine_EventSink,
	/*Universal name*/	"SampleToolDef_Line",
	/*Version*/			1,
	/*UUID*/			0x45c740d8, 0xb0d5, 0x43d7, 0xa7, 0x3b, 0x39, 0x1a, 0xb0, 0x19, 0xcf, 0x85 );

// Test with VectorScript:
// SetSelect(CreateCustomObject('SampleToolDef_Line',0,0,0));

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjTheLine::CExtObjTheLine(CallBackPtr cbp)
	: VWExtensionParametric( cbp, gParametricDef, gArrParameters )
//	: VWExtensionParametric( cbp, gParametricDef, gArrParameters, gArrChoices )
{
}

CExtObjTheLine::~CExtObjTheLine()
{
}

// --------------------------------------------------------------------------------------------------------
// {A05B4443-7D21-427E-8962-3C45DCB99F70}
IMPLEMENT_VWExtension(
	/*Extension class*/	CExtObjTheLineDefTool,
	/*Event sink*/		CExtObjTheLineDefTool_EventSink,
	/*Universal name*/	"SampleToolDef_LineTool",
	/*Version*/			1,
	/*UUID*/			0xa05b4443, 0x7d21, 0x427e, 0x89, 0x62, 0x3c, 0x45, 0xdc, 0xb9, 0x9f, 0x70 );

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjTheLineDefTool::CExtObjTheLineDefTool(CallBackPtr cbp)
	: VWExtensionTool( cbp, gToolDef )
{
}

CExtObjTheLineDefTool::~CExtObjTheLineDefTool()
{
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjTheLineDefTool_EventSink::CExtObjTheLineDefTool_EventSink(IVWUnknown* parent)
	: VWToolDefaultLine_EventSink( parent, "SampleToolDef_Point" )
{
	memset( fBarState, 0, sizeof(fBarState) );

	// default values for our groups
	fBarState[0]	= 0;
	fBarState[2]	= 1;
}

CExtObjTheLineDefTool_EventSink::~CExtObjTheLineDefTool_EventSink()
{
}

void CExtObjTheLineDefTool_EventSink::Init(const TXString& universalName)
{
	SDefaultLineToolInfo	toolInfo	= this->GetToolInfo();

	toolInfo.fModeGroup					= 2;	// group 2
	toolInfo.fConstrainedChoiceIndex	= 1;	// fModeGroup:	button index 1
	toolInfo.fUnconstrainedChoiceIndex	= 3;	//				button index 3

	this->SetToolInfo( toolInfo );

	VWToolDefaultLine_EventSink::Init( universalName );
}

bool CExtObjTheLineDefTool_EventSink::DoSetUp(bool bRestore, const IToolModeBarInitProvider* modeBarInitProvider)
{
	// NOTE! the constructor initializes
	// the default values of fBarState
	
	const IToolModeBar2InitProvider* p2 = dynamic_cast<const IToolModeBar2InitProvider*> (modeBarInitProvider);
	if (p2)
	{
		TXStringArray imageSpecs;
		imageSpecs.Append("DefaultTools/SampleToolButtonA.png");
		imageSpecs.Append("DefaultTools/SampleToolButtonB.png");
		
		p2->AddRadioModeGroup2( /*group 0*/ fBarState[0], imageSpecs);
		p2->AddButtonModeGroup2("DefaultTools/SampleToolButtonB.png");
		
		// NOTE! The sample uses Vectorworks icons for this group.
		// This could be dangerous since these numbers are not guaranteed and may change in the future
		imageSpecs.Append("Vectorworks/ModeViewBar/Classes.png");
		p2->AddRadioModeGroup2( /*group 2*/ fBarState[2], imageSpecs);
		
		p2->AddButtonModeGroup2( /*group 3*/ "Vectorworks/ModeViewBar/Options.png" );
	}
	
	TXStringArray	arrButtonsHelps;
//	arrButtonsHelps.Append( TXString( (short)11100, (short)10 ) );
//	arrButtonsHelps.Append( TXString( (short)11100, (short)11 ) );
//	arrButtonsHelps.Append( TXString( (short)11100, (short)12 ) );
//	arrButtonsHelps.Append( TXString( (short)11100, (short)13 ) );
//	arrButtonsHelps.Append( TXString( (short)11100, (short)14 ) );
//	arrButtonsHelps.Append( TXString( (short)11100, (short)15 ) );
//	arrButtonsHelps.Append( TXString( (short)11100, (short)16 ) );
//	arrButtonsHelps.Append( TXString( (short)11100, (short)17 ) );
//	arrButtonsHelps.Append( TXString( (short)11100, (short)18 ) );
//	pModeBarInitProvider->SetButtonsHelpText( arrButtonsHelps );

	return VWToolDefaultLine_EventSink::DoSetUp( bRestore, modeBarInitProvider );
}

void CExtObjTheLineDefTool_EventSink::DoModeEvent(size_t modeGroupID, size_t newButtonID, size_t oldButtonID)
{
	// save the state so to be able to restore the mode bar proerly
	fBarState[ modeGroupID ]	= newButtonID;

	// just for fun, show a dialog
	TXString	msg;
	msg.Format( "groupID: %d newButtonID: %d oldButtonID: %d", modeGroupID, newButtonID, oldButtonID );
	gSDK->AlertInform( "CExtObjThePointDefTool_EventSink::DoModeEvent", msg );

	VWToolDefaultLine_EventSink::DoModeEvent( modeGroupID, newButtonID, oldButtonID );
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CObjTheLine_EventSink::CObjTheLine_EventSink(IVWUnknown* parent)
	: VWParametric_EventSink( parent )
{
}

CObjTheLine_EventSink::~CObjTheLine_EventSink()
{
}

EObjectEvent CObjTheLine_EventSink::OnInitXProperties(CodeRefID objectID)
{
	// obtain the interfact for accessing the extended properties
	using namespace VectorWorks::Extension;
	VCOMPtr<IExtendedProps>	extProps( IID_ExtendedProps );



	return kObjectEventNoErr;
}

EObjectEvent CObjTheLine_EventSink::Recalculate()
{
	VWPoint3D	offset( -500, 0, 0 );

	VWPolygon3DObj	poly;
	poly.AddVertex( offset + VWPoint3D(50, 100, 0) );
	poly.AddVertex( offset + VWPoint3D(1000, 0, 0) );
	poly.AddVertex( offset + VWPoint3D(1000, 1000, 0) );
	poly.AddVertex( offset + VWPoint3D(100, 800, 0) );
	poly.SetClosed( true );

	return kObjectEventNoErr;
}
