#include "StdAfx.h"

#include "PluginResource.h"

#include "ExtObjThePoint.h"

using namespace Tester;

namespace Tester
{
	// --------------------------------------------------------------------------------------------------------
	static SToolDef		gToolDef = {
		/*ToolType*/					eExtensionToolType_Normal,
		/*ParametricName*/				"SampleToolDef_Point",
		/*PickAndUpdate*/				ToolDef::pickAndUpdate,
		/*NeedScreenPlane*/				ToolDef::doesntNeedScreenPlane,
		/*Need3DProjection*/			ToolDef::doesntNeed3DView,
		/*Use2DCursor*/					ToolDef::use2DCursor,
		/*ConstrainCursor*/				ToolDef::constrainCursor,
		/*NeedPerspective*/				ToolDef::doesntNeedPerspective,
		/*ShowScreenHints*/				ToolDef::showScreenHints,
		/*NeedsPlanarContext*/			ToolDef::needsPlanarContext,
		/*Reserved1*/					false,
		/*Reserved2*/					0,
		/*Reserved3*/					0,
		/*Reserved4*/					0,
		/*Message*/						{11000, 4},
		/*WaitMoveDistance*/			0,
		/*ConstraintFlags*/				0,
		/*BarDisplay*/					kToolBarDisplay_XYClLaZo,
		/*MinimumCompatibleVersion*/	900,
		/*Title*/						{11000, 2},
		/*Category*/					{11000, 3},
		/*HelpText*/					{11000},
		/*VersionCreated*/				16,
		/*VersoinModified*/				0,
		/*VersoinRetired*/				0,
		/*contextual help*/				"",
		/*Icon Specifier*/				"DefaultTools/ExtObjThePointDefTool.png",
		/*Cursor Specifier*/			""
	};

	// --------------------------------------------------------------------------------------------------------
	static SParametricDef gParametricDef = {
		/*LocalizedName*/			{11000, 1},
		/*SubType*/					kParametricSubType_Point,
		/*ResetOnMove*/				false,
		/*ResetOnRotate*/			false,
		/*WallInsertOnEdge*/		false,
		/*WallInsertNoBreak*/		false,
		/*WallInsertHalfBreak*/		false,
		/*WallInsertHideCaps*/		false,
	};

/*
 static SParametricParamChc	gArrChoices[] = {
		{ 128,	"Line",					{11002, 1} },
		{ 128,	"Arc",					{11002, 2} },
		{ 128,	"Bezier",				{11002, 3} },
		{ 128,	"None",					{11002, 4} },
		//------
		{ 129,	"Default Legend",		{11002, 5} },
		//------
		// TERMINATE
		{ NULL, NULL, {0,0} }
	};
*/
	static SParametricParamDef gArrParameters[] = {
		{ "p1",			{11001, 1},		"False",	"False",	kFieldBoolean,		0 },
		{ "p2",			{11001, 2},		"False",	"False",	kFieldBoolean,		0 },
		{ "p3",			{11001, 3},		"",			"",			kFieldText,			0 },
		{ "p4",			{11001, 4},		"",			"",			kFieldText,			0 },
		{ "p5",			{11001, 5},		"2\"",		"2\"",		kFieldCoordDisp,	0 },
		{ "p6",			{11001, 6},		"Auto",		"Auto",		kFieldPopUp,		128 },
		{ "p7",			{11001, 7},		"Auto",		"Auto",		kFieldPopUp,		129 },
		// TERMINATE
		{ NULL, {0,0}, NULL, NULL, EFieldStyle(0), 0 }
	};
}


// --------------------------------------------------------------------------------------------------------
// {5376CFDC-9E15-4F12-82AA-688EB18AAD4C}
IMPLEMENT_VWExtension(
	/*Extension class*/	CExtObjThePoint,
	/*Event sink*/		CObjThePoint_EventSink,
	/*Universal name*/	"SampleToolDef_Point",
	/*Version*/			1,
	/*UUID*/			0x5376cfdc, 0x9e15, 0x4f12, 0x82, 0xaa, 0x68, 0x8e, 0xb1, 0x8a, 0xad, 0x4c );

// Test with VectorScript:
// SetSelect(CreateCustomObject('SampleToolDef_Point',0,0,0));

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjThePoint::CExtObjThePoint(CallBackPtr cbp)
	: VWExtensionParametric( cbp, gParametricDef, gArrParameters )
//	: VWExtensionParametric( cbp, gParametricDef, gArrParameters, gArrChoices )
{
}

CExtObjThePoint::~CExtObjThePoint()
{
}

// --------------------------------------------------------------------------------------------------------
// {D680D90A-D19B-45F1-8B4F-4EDFE9298C84}
IMPLEMENT_VWExtension(
	/*Extension class*/	CExtObjThePointDefTool,
	/*Event sink*/		CExtObjThePointDefTool_EventSink,
	/*Universal name*/	"SampleToolDef_PointTool",
	/*Version*/			1,
	/*UUID*/			0xd680d90a, 0xd19b, 0x45f1, 0x8b, 0x4f, 0x4e, 0xdf, 0xe9, 0x29, 0x8c, 0x84 );

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjThePointDefTool::CExtObjThePointDefTool(CallBackPtr cbp)
	: VWExtensionTool( cbp, gToolDef )
{
}

CExtObjThePointDefTool::~CExtObjThePointDefTool()
{
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjThePointDefTool_EventSink::CExtObjThePointDefTool_EventSink(IVWUnknown* parent)
	: VWToolDefaultPoint_EventSink( parent, "SampleToolDef_Point" )
{
	memset( fBarState, 0, sizeof(fBarState) );

	// default values for our groups
	fBarState[0]	= 0;
	fBarState[2]	= 0;
	fBarState[3]	= 3;
}

CExtObjThePointDefTool_EventSink::~CExtObjThePointDefTool_EventSink()
{
}

void CExtObjThePointDefTool_EventSink::Init(const TXString& universalName)
{
	SDefaultPointToolInfo	toolInfo	= this->GetToolInfo();

	toolInfo.fModeGroup              	= 2;	// group 2
	toolInfo.fAlignmentGroup         	= 3;	// group 3
	toolInfo.fRegularInsChoiceIndex  	= 0;	// fModeGroup:	button index 0
	toolInfo.fOffsetInsChoiceIndex   	= 1;	//				button index 1
	toolInfo.fLeftChoiceIndex        	= 0;	// fAlignmentGroup:	button index 0
	toolInfo.fCenterChoiceIndex      	= 1;	//					button index 1
	toolInfo.fRightChoiceIndex       	= 2;	//					button index 2
	toolInfo.fNaturalChoiceIndex     	= 3;	//					button index 3

	this->SetToolInfo( toolInfo );

	VWToolDefaultPoint_EventSink::Init( universalName );
}

bool CExtObjThePointDefTool_EventSink::DoSetUp(bool bRestore, const IToolModeBarInitProvider* modeBarInitProvider)
{
	// NOTE! the constructor initializes
	// the default values of fBarState

	const IToolModeBar2InitProvider* p2 = dynamic_cast<const IToolModeBar2InitProvider*> (modeBarInitProvider);
	if (p2)
	{
		TXStringArray imageSpecs;
		imageSpecs.Append("DefaultTools/SampleToolButtonA.png");
		imageSpecs.Append("DefaultTools/SampleToolButtonB.png");
		
		p2->AddRadioModeGroup2( /*group 0*/ fBarState[0], imageSpecs);
		p2->AddButtonModeGroup2("DefaultTools/SampleToolButtonB.png");
		
		// NOTE! The sample uses Vectorworks icons for this group.
		// This could be dangerous since these numbers are not guaranteed and may change in the future
		imageSpecs.Append("Vectorworks/ModeViewBar/Classes.png");
		p2->AddRadioModeGroup2( /*group 2*/ fBarState[2], imageSpecs);
		
		p2->AddButtonModeGroup2( /*group 3*/ "Vectorworks/ModeViewBar/Options.png" );
	}

	TXStringArray	arrButtonsHelps;
//	arrButtonsHelps.Append( TXString( (short)11000, (short)10 ) );
//	arrButtonsHelps.Append( TXString( (short)11000, (short)11 ) );
//	arrButtonsHelps.Append( TXString( (short)11000, (short)12 ) );
//	arrButtonsHelps.Append( TXString( (short)11000, (short)13 ) );
//	arrButtonsHelps.Append( TXString( (short)11000, (short)14 ) );
//	arrButtonsHelps.Append( TXString( (short)11000, (short)15 ) );
//	arrButtonsHelps.Append( TXString( (short)11000, (short)16 ) );
//	arrButtonsHelps.Append( TXString( (short)11000, (short)17 ) );
//	arrButtonsHelps.Append( TXString( (short)11000, (short)18 ) );
//	modeBarInitProvider->SetButtonsHelpText( arrButtonsHelps );

	return VWToolDefaultPoint_EventSink::DoSetUp( bRestore, modeBarInitProvider );
}

void CExtObjThePointDefTool_EventSink::DoModeEvent(size_t modeGroupID, size_t newButtonID, size_t oldButtonID)
{
	// save the state so to be able to restore the mode bar proerly
	fBarState[ modeGroupID ]	= newButtonID;

	// just for fun, show a dialog
	TXString	msg;
	msg.Format( "groupID: %d newButtonID: %d oldButtonID: %d", modeGroupID, newButtonID, oldButtonID );
	gSDK->AlertInform( "CExtObjThePointDefTool_EventSink::DoModeEvent", msg );

	VWToolDefaultPoint_EventSink::DoModeEvent( modeGroupID, newButtonID, oldButtonID );
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CObjThePoint_EventSink::CObjThePoint_EventSink(IVWUnknown* parent)
	: VWParametric_EventSink( parent )
{
}

CObjThePoint_EventSink::~CObjThePoint_EventSink()
{
}

EObjectEvent CObjThePoint_EventSink::OnInitXProperties(CodeRefID objectID)
{
	// obtain the interfact for accessing the extended properties
	using namespace VectorWorks::Extension;
	VCOMPtr<IExtendedProps>	extProps( IID_ExtendedProps );



	return kObjectEventNoErr;
}

EObjectEvent CObjThePoint_EventSink::Recalculate()
{
	VWPoint3D	offset( -500, 0, 0 );

	VWPolygon3DObj	poly;
	poly.AddVertex( offset + VWPoint3D(50, 100, 0) );
	poly.AddVertex( offset + VWPoint3D(1000, 0, 0) );
	poly.AddVertex( offset + VWPoint3D(1000, 1000, 0) );
	poly.AddVertex( offset + VWPoint3D(100, 800, 0) );
	poly.SetClosed( true );

	return kObjectEventNoErr;
}
