#include "StdAfx.h"

#include "PluginResource.h"

#include "ExtObjThePoly2D.h"

using namespace Tester;

namespace Tester
{
	// --------------------------------------------------------------------------------------------------------
	static SToolDef		gToolDef = {
		/*ToolType*/					eExtensionToolType_Normal,
		/*ParametricName*/				"SampleToolDef_Poly2D",
		/*PickAndUpdate*/				ToolDef::pickAndUpdate,
		/*NeedScreenPlane*/				ToolDef::doesntNeedScreenPlane,
		/*Need3DProjection*/			ToolDef::doesntNeed3DView,
		/*Use2DCursor*/					ToolDef::use2DCursor,
		/*ConstrainCursor*/				ToolDef::constrainCursor,
		/*NeedPerspective*/				ToolDef::doesntNeedPerspective,
		/*ShowScreenHints*/				ToolDef::showScreenHints,
		/*NeedsPlanarContext*/			ToolDef::needsPlanarContext,
		/*Reserved1*/					false,
		/*Reserved2*/					0,
		/*Reserved3*/					0,
		/*Reserved4*/					0,
		/*Message*/						{11300, 4},
		/*WaitMoveDistance*/			0,
		/*ConstraintFlags*/				0,
		/*BarDisplay*/					kToolBarDisplay_XYClLaZo,
		/*MinimumCompatibleVersion*/	900,
		/*Title*/						{11300, 2},
		/*Category*/					{11300, 3},
		/*HelpText*/					{11300},
		/*VersionCreated*/				16,
		/*VersoinModified*/				0,
		/*VersoinRetired*/				0,
		/*contextual help*/				"",
		/*Icon Specifier*/				"DefaultTools/ExtObjThePoly2DDefTool.png",
		/*Cursor Specifier*/			""
	};

	// --------------------------------------------------------------------------------------------------------
	static SParametricDef gParametricDef = {
		/*LocalizedName*/			{11300, 1},
		/*SubType*/					kParametricSubType_2DPath,
		/*ResetOnMove*/				false,
		/*ResetOnRotate*/			false,
		/*WallInsertOnEdge*/		false,
		/*WallInsertNoBreak*/		false,
		/*WallInsertHalfBreak*/		false,
		/*WallInsertHideCaps*/		false,
	};

/*	static SParametricParamChc	gArrChoices[] = {
		{ 128,	"Line",					{11302, 1} },
		{ 128,	"Arc",					{11302, 2} },
		{ 128,	"Bezier",				{11302, 3} },
		{ 128,	"None",					{11302, 4} },
		//------
		{ 129,	"Default Legend",		{11302, 5} },
		//------
		// TERMINATE
		{ NULL, NULL, {0,0} }
	};
*/
	static SParametricParamDef gArrParameters[] = {
		{ "p1",			{11301, 1},		"False",	"False",	kFieldBoolean,		0 },
		{ "p2",			{11301, 2},		"False",	"False",	kFieldBoolean,		0 },
		{ "p3",			{11301, 3},		"",			"",			kFieldText,			0 },
		{ "p4",			{11301, 4},		"",			"",			kFieldText,			0 },
		{ "p5",			{11301, 5},		"2\"",		"2\"",		kFieldCoordDisp,	0 },
		{ "p6",			{11301, 6},		"Auto",		"Auto",		kFieldPopUp,		128 },
		{ "p7",			{11301, 7},		"Auto",		"Auto",		kFieldPopUp,		129 },
		// TERMINATE
		{ NULL, {0,0}, NULL, NULL, EFieldStyle(0), 0 }
	};
}


// --------------------------------------------------------------------------------------------------------
// {0DCA59C5-4A13-4A67-8026-AED463ED07DC}
IMPLEMENT_VWExtension(
	/*Extension class*/	CExtObjThePoly2D,
	/*Event sink*/		CObjThePoly2D_EventSink,
	/*Universal name*/	"SampleToolDef_Poly2D",
	/*Version*/			1,
	/*UUID*/			0xdca59c5, 0x4a13, 0x4a67, 0x80, 0x26, 0xae, 0xd4, 0x63, 0xed, 0x7, 0xdc );

// Test with VectorScript:
// SetSelect(CreateCustomObject('SampleToolDef_Poly2D',0,0,0));

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjThePoly2D::CExtObjThePoly2D(CallBackPtr cbp)
	: VWExtensionParametric( cbp, gParametricDef, gArrParameters )
//	: VWExtensionParametric( cbp, gParametricDef, gArrParameters, gArrChoices )
{
}

CExtObjThePoly2D::~CExtObjThePoly2D()
{
}

// --------------------------------------------------------------------------------------------------------
// {7C8D90BD-5401-4788-9B2E-CD65E9341BD1}
IMPLEMENT_VWExtension(
	/*Extension class*/	CExtObjThePoly2DDefTool,
	/*Event sink*/		CExtObjThePoly2DDefTool_EventSink,
	/*Universal name*/	"SampleToolDef_Poly2DTool",
	/*Version*/			1,
	/*UUID*/			0x7c8d90bd, 0x5401, 0x4788, 0x9b, 0x2e, 0xcd, 0x65, 0xe9, 0x34, 0x1b, 0xd1 );

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjThePoly2DDefTool::CExtObjThePoly2DDefTool(CallBackPtr cbp)
	: VWExtensionTool( cbp, gToolDef )
{
}

CExtObjThePoly2DDefTool::~CExtObjThePoly2DDefTool()
{
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjThePoly2DDefTool_EventSink::CExtObjThePoly2DDefTool_EventSink(IVWUnknown* parent)
	: VWToolDefault2DPoly_EventSink( parent, "SampleToolDef_Point" )
{
	memset( fBarState, 0, sizeof(fBarState) );

	// default values for our groups
	fBarState[0]	= 0;
	fBarState[2]	= 0;
}

CExtObjThePoly2DDefTool_EventSink::~CExtObjThePoly2DDefTool_EventSink()
{
}

void CExtObjThePoly2DDefTool_EventSink::Init(const TXString& universalName)
{
	SDefault2DPolyToolInfo	toolInfo	= this->GetToolInfo();

	toolInfo.fModeGroup			= 2;	// group 2
	toolInfo.fFiletRadiusGroup	= 3;	// group 3

	toolInfo.fCornerVertChoiceIndex	= 0;	//fModeGroup:	button index 0	
	toolInfo.fBezierVertChoiceIndex	= 1;	//				button index 1
	toolInfo.fCubicVertChoiceIndex	= 2;	//				button index 2
	toolInfo.fTangetChoiceIndex		= 3;	//				button index 3
	toolInfo.fPointOnArcChoiceIndex	= 4;	//				button index 4
	toolInfo.fArcVertChoiceIndex	= 5;	//				button index 5

	this->SetToolInfo( toolInfo );

	VWToolDefault2DPoly_EventSink::Init( universalName );
}

bool CExtObjThePoly2DDefTool_EventSink::DoSetUp(bool bRestore, const IToolModeBarInitProvider* modeBarInitProvider)
{
	// NOTE! the constructor initializes
	// the default values of fBarState

	TXStringArray imageSpecs;
	imageSpecs.Append("DefaultTools/SampleToolButtonA.png");
	imageSpecs.Append("DefaultTools/SampleToolButtonB.png");
	
	const IToolModeBar2InitProvider* p2 = dynamic_cast<const IToolModeBar2InitProvider*> (modeBarInitProvider);
	if (p2)
	{
		p2->AddRadioModeGroup2( /*group 0*/ fBarState[0], imageSpecs);
		p2->AddButtonModeGroup2("DefaultTools/SampleToolButtonB.png");
		
		// NOTE! The sample uses Vectorworks icons for this group.
		// This could be dangerous since these numbers are not guaranteed and may change in the future
		imageSpecs.Append("Vectorworks/ModeViewBar/Classes.png");
		p2->AddRadioModeGroup2( /*group 2*/ fBarState[2], imageSpecs);
		
		p2->AddButtonModeGroup2( /*group 3*/ "Vectorworks/ModeViewBar/Options.png" );	
	}
	TXStringArray	arrButtonsHelps;
	arrButtonsHelps.Append( TXString( (short)11300, (short)10 ) );
	arrButtonsHelps.Append( TXString( (short)11300, (short)11 ) );
	arrButtonsHelps.Append( TXString( (short)11300, (short)12 ) );
	arrButtonsHelps.Append( TXString( (short)11300, (short)13 ) );
	arrButtonsHelps.Append( TXString( (short)11300, (short)14 ) );
	arrButtonsHelps.Append( TXString( (short)11300, (short)15 ) );
	arrButtonsHelps.Append( TXString( (short)11300, (short)16 ) );
	arrButtonsHelps.Append( TXString( (short)11300, (short)17 ) );
	arrButtonsHelps.Append( TXString( (short)11300, (short)18 ) );
	modeBarInitProvider->SetButtonsHelpText( arrButtonsHelps );

	return VWToolDefault2DPoly_EventSink::DoSetUp( bRestore, modeBarInitProvider );
}

void CExtObjThePoly2DDefTool_EventSink::DoModeEvent(size_t modeGroupID, size_t newButtonID, size_t oldButtonID)
{
	// save the state so to be able to restore the mode bar proerly
	fBarState[ modeGroupID ]	= newButtonID;

	// just for fun, show a dialog
	TXString	msg;
	msg.Format( "groupID: %d newButtonID: %d oldButtonID: %d", modeGroupID, newButtonID, oldButtonID );
	gSDK->AlertInform( "CExtObjThePoly2DDefTool_EventSink::DoModeEvent", msg );

	VWToolDefault2DPoly_EventSink::DoModeEvent( modeGroupID, newButtonID, oldButtonID );
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CObjThePoly2D_EventSink::CObjThePoly2D_EventSink(IVWUnknown* parent)
	: VWParametric_EventSink( parent )
{
}

CObjThePoly2D_EventSink::~CObjThePoly2D_EventSink()
{
}

EObjectEvent CObjThePoly2D_EventSink::OnInitXProperties(CodeRefID objectID)
{
	// obtain the interfact for accessing the extended properties
	using namespace VectorWorks::Extension;
	VCOMPtr<IExtendedProps>	extProps( IID_ExtendedProps );



	return kObjectEventNoErr;
}

EObjectEvent CObjThePoly2D_EventSink::Recalculate()
{
	VWPoint3D	offset( -500, 0, 0 );

	VWPolygon3DObj	poly;
	poly.AddVertex( offset + VWPoint3D(50, 100, 0) );
	poly.AddVertex( offset + VWPoint3D(1000, 0, 0) );
	poly.AddVertex( offset + VWPoint3D(1000, 1000, 0) );
	poly.AddVertex( offset + VWPoint3D(100, 800, 0) );
	poly.SetClosed( true );

	return kObjectEventNoErr;
}
