#include "StdAfx.h"

#include "PluginResource.h"

#include "ExtObjThePoly3D.h"

using namespace Tester;

namespace Tester
{
	// --------------------------------------------------------------------------------------------------------
	static SToolDef		gToolDef = {
		/*ToolType*/					eExtensionToolType_Normal,
		/*ParametricName*/				"SampleToolDef_Poly3D",
		/*PickAndUpdate*/				ToolDef::pickAndUpdate,
		/*NeedScreenPlane*/				ToolDef::doesntNeedScreenPlane,
		/*Need3DProjection*/			ToolDef::doesntNeed3DView,
		/*Use2DCursor*/					ToolDef::use2DCursor,
		/*ConstrainCursor*/				ToolDef::constrainCursor,
		/*NeedPerspective*/				ToolDef::doesntNeedPerspective,
		/*ShowScreenHints*/				ToolDef::showScreenHints,
		/*NeedsPlanarContext*/			ToolDef::needsPlanarContext,
		/*Reserved1*/					false,
		/*Reserved2*/					0,
		/*Reserved3*/					0,
		/*Reserved4*/					0,
		/*Message*/						{11400, 4},
		/*WaitMoveDistance*/			0,
		/*ConstraintFlags*/				0,
		/*BarDisplay*/					kToolBarDisplay_XYClLaZo,
		/*MinimumCompatibleVersion*/	900,
		/*Title*/						{11400, 2},
		/*Category*/					{11400, 3},
		/*HelpText*/					{11400},
		/*VersionCreated*/				16,
		/*VersoinModified*/				0,
		/*VersoinRetired*/				0,
		/*contextual help*/				"",
		/*Icon Specifier*/				"DefaultTools/ExtObjThePoly3DDefTool.png",
		/*Cursor Specifier*/			""
	};

	// --------------------------------------------------------------------------------------------------------
	static SParametricDef gParametricDef = {
		/*LocalizedName*/			{11400, 1},
		/*SubType*/					kParametricSubType_3DPath,
		/*ResetOnMove*/				false,
		/*ResetOnRotate*/			false,
		/*WallInsertOnEdge*/		false,
		/*WallInsertNoBreak*/		false,
		/*WallInsertHalfBreak*/		false,
		/*WallInsertHideCaps*/		false,
	};

/*	static SParametricParamChc	gArrChoices[] = {
		{ 128,	"Line",					{11002, 1} },
		{ 128,	"Arc",					{11002, 2} },
		{ 128,	"Bezier",				{11002, 3} },
		{ 128,	"None",					{11002, 4} },
		//------
		{ 129,	"Default Legend",		{11002, 5} },
		//------
		// TERMINATE
		{ NULL, NULL, {0,0} }
	};
*/
	static SParametricParamDef gArrParameters[] = {
		{ "p1",			{11001, 1},		"False",	"False",	kFieldBoolean,		0 },
		{ "p2",			{11001, 2},		"False",	"False",	kFieldBoolean,		0 },
		{ "p3",			{11001, 3},		"",			"",			kFieldText,			0 },
		{ "p4",			{11001, 4},		"",			"",			kFieldText,			0 },
		{ "p5",			{11001, 5},		"2\"",		"2\"",		kFieldCoordDisp,	0 },
		{ "p6",			{11001, 6},		"Auto",		"Auto",		kFieldPopUp,		128 },
		{ "p7",			{11001, 7},		"Auto",		"Auto",		kFieldPopUp,		129 },
		// TERMINATE
		{ NULL, {0,0}, NULL, NULL, EFieldStyle(0), 0 }
	};
}


// --------------------------------------------------------------------------------------------------------
// {F4A67936-3B0A-45F7-A2F5-9BD513108D31}
IMPLEMENT_VWExtension(
	/*Extension class*/	CExtObjThePoly3D,
	/*Event sink*/		CObjThePoly3D_EventSink,
	/*Universal name*/	"SampleToolDef_Poly3D",
	/*Version*/			1,
	/*UUID*/			0xf4a67936, 0x3b0a, 0x45f7, 0xa2, 0xf5, 0x9b, 0xd5, 0x13, 0x10, 0x8d, 0x31 );

// Test with VectorScript:
// SetSelect(CreateCustomObject('SampleToolDef_Poly3D',0,0,0));

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjThePoly3D::CExtObjThePoly3D(CallBackPtr cbp)
	: VWExtensionParametric( cbp, gParametricDef, gArrParameters )
//	: VWExtensionParametric( cbp, gParametricDef, gArrParameters, gArrChoices )
{
}

CExtObjThePoly3D::~CExtObjThePoly3D()
{
}

// --------------------------------------------------------------------------------------------------------
// {41B4542E-33A2-4B94-8341-AE32FB2130C8}
IMPLEMENT_VWExtension(
	/*Extension class*/	CExtObjThePoly3DDefTool,
	/*Event sink*/		CExtObjThePoly3DDefTool_EventSink,
	/*Universal name*/	"SampleToolDef_Poly3DTool",
	/*Version*/			1,
	/*UUID*/			0x41b4542e, 0x33a2, 0x4b94, 0x83, 0x41, 0xae, 0x32, 0xfb, 0x21, 0x30, 0xc8 );

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjThePoly3DDefTool::CExtObjThePoly3DDefTool(CallBackPtr cbp)
	: VWExtensionTool( cbp, gToolDef )
{
}

CExtObjThePoly3DDefTool::~CExtObjThePoly3DDefTool()
{
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CExtObjThePoly3DDefTool_EventSink::CExtObjThePoly3DDefTool_EventSink(IVWUnknown* parent)
	: VWToolDefault3DPoly_EventSink( parent, "SampleToolDef_Point" )
{
}

CExtObjThePoly3DDefTool_EventSink::~CExtObjThePoly3DDefTool_EventSink()
{
}

void CExtObjThePoly3DDefTool_EventSink::Init(const TXString& universalName)
{
	SDefault3DPolyToolInfo	toolInfo	= this->GetToolInfo();

	toolInfo.fModeGroup	= 0;
	toolInfo.fNURBSByInterpChoiceIndex	= 0;

	this->SetToolInfo( toolInfo );

	VWToolDefault3DPoly_EventSink::Init( universalName );
}

bool CExtObjThePoly3DDefTool_EventSink::DoSetUp(bool bRestore, const IToolModeBarInitProvider* modeBarInitProvider)
{	
	const IToolModeBar2InitProvider* p2 = dynamic_cast<const IToolModeBar2InitProvider*> (modeBarInitProvider);
	if (p2)
	{
		p2->AddButtonModeGroup2("DefaultTools/SampleToolButtonA.png");
		p2->AddButtonModeGroup2("DefaultTools/SampleToolButtonB.png");
		p2->AddButtonModeGroup2("DefaultTools/SampleToolButtonC.png");
	}
	return VWToolDefault3DPoly_EventSink::DoSetUp( bRestore, modeBarInitProvider );
}

// --------------------------------------------------------------------------------------------------------
// --------------------------------------------------------------------------------------------------------
CObjThePoly3D_EventSink::CObjThePoly3D_EventSink(IVWUnknown* parent)
	: VWParametric_EventSink( parent )
{
}

CObjThePoly3D_EventSink::~CObjThePoly3D_EventSink()
{
}

EObjectEvent CObjThePoly3D_EventSink::OnInitXProperties(CodeRefID objectID)
{
	// obtain the interfact for accessing the extended properties
	using namespace VectorWorks::Extension;
	VCOMPtr<IExtendedProps>	extProps( IID_ExtendedProps );



	return kObjectEventNoErr;
}

EObjectEvent CObjThePoly3D_EventSink::Recalculate()
{
	VWPoint3D	offset( -500, 0, 0 );

	VWPolygon3DObj	poly;
	poly.AddVertex( offset + VWPoint3D(50, 100, 0) );
	poly.AddVertex( offset + VWPoint3D(1000, 0, 0) );
	poly.AddVertex( offset + VWPoint3D(1000, 1000, 0) );
	poly.AddVertex( offset + VWPoint3D(100, 800, 0) );
	poly.SetClosed( true );

	return kObjectEventNoErr;
}
