PROCEDURE SampleDlg2;
CONST
    {Alignment constants}
    kRight                = 1;
    kBottom               = 2;
    kLeft                 = 3;
    kResize               = 0;
    kShift                = 1;

    { dialog resource ID }
    kTextStrTableID       = 12001;

    { default and cancel button IDs}
    kOK                   = 1;
    kCancel               = 2;

    { control IDs}
    kListBoxText          = 4;
    kListBox1             = 5;
    kListBrowserText      = 6;
    kListBrowser          = 7;
    kListBox2             = 8;

VAR
    dialog            :INTEGER;
    cnt               :INTEGER;

FUNCTION GetStr(ndx :INTEGER) :STRING;
BEGIN
    GetResourceString(GetStr, kTextStrTableID, ndx);
END;

FUNCTION GetHelpStr(ndx :INTEGER) :STRING;
BEGIN
    GetResourceString(GetHelpStr, kTextStrTableID, ndx + 8);
END;

BEGIN
    dialog := CreateResizableLayout(GetStr(3), TRUE, GetStr(kOK), GetStr(kCancel), TRUE, TRUE );

    {create controls}
    CreateStaticText( dialog, kListBoxText, GetStr(kListBoxText), -1 );
    CreateListBox( dialog, kListBox1, 25, 10 );
    CreateListBox( dialog, kListBox2, 25, 10 );
    CreateStaticText( dialog, kListBrowserText, GetStr(kListBrowserText), -1 );
    CreateLB( dialog, kListBrowser, 50, 10 );

    {set relations}
    SetFirstLayoutItem( dialog, kListBoxText );
    SetBelowItem( dialog, kListBoxText, kListBox1, 0, 0 );
    SetRightItem( dialog, kListBox1, kListBox2, 0, 0 );
    SetBelowItem( dialog, kListBox1, kListBrowserText, 0, 0 );
    SetBelowItem( dialog, kListBrowserText, kListBrowser, 0, 0 );

    {set alignments}
    AlignItemEdge( dialog, kListBrowser, kRight, 1, kResize );
    AlignItemEdge( dialog, kListBox2, kRight, 1, kResize );

    {set bindings}
    SetEdgeBinding        ( dialog, kListBox1, TRUE, TRUE, FALSE, FALSE );
    SetProportionalBinding( dialog, kListBox1, FALSE, TRUE, FALSE, FALSE );
    SetEdgeBinding        ( dialog, kListBox2, TRUE, TRUE, FALSE, FALSE );
    SetProportionalBinding( dialog, kListBox2, TRUE, FALSE, FALSE, FALSE );

    {set help strings}
    FOR cnt := 1 TO 8 DO SetHelpText(dialog, cnt, GetHelpStr(cnt));

    { uncomment to test the script
    IF RunLayoutDialog( dialog, NIL ) = 1 then BEGIN
    END;}

END;
RUN( SampleDlg2 );

{XML defintion of the layout}
{<BEGIN_XML>
<?xml version="1.0" encoding="UTF-8" standalone="no" ?>
<DialogBuilder>

  <LayoutData>
    <Name>SampleDlg2</Name>
    <Namespace></Namespace>
    <Title>Sample Dialog 2</Title>
    <OKText>OK</OKText>
    <OKHelpText>Accepts the dialog data.</OKHelpText>
    <CancelText>Cancel</CancelText>
    <CancelHelpText>Cancels the dialog data.</CancelHelpText>
    <HasHelp>TRUE</HasHelp>
    <ResizableWidth>TRUE</ResizableWidth>
    <ResizableHeight>TRUE</ResizableHeight>
    <StringsStartID>12001</StringsStartID>
    <HelpStrsInTable>FALSE</HelpStrsInTable>
    <HelpStrStartID>12002</HelpStrStartID>
    <ControlPrefix>k</ControlPrefix>
    <ShowControlIDs>TRUE</ShowControlIDs>
    <TablesAddToDlgRes>TRUE</TablesAddToDlgRes>
    <ExportXMLinVS>TRUE</ExportXMLinVS>
  </LayoutData>

  <Controls>
    <Control name="DialogBuilderControl" x="-39.000000" y="66.000000">
      <Parameter Name="__UUID">%LBFFA206A4-E03B-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="__locked">false</Parameter>
      <Parameter Name="type">kStaticText</Parameter>
      <Parameter Name="id">4</Parameter>
      <Parameter Name="constName">ListBoxText</Parameter>
      <Parameter Name="label">List Box</Parameter>
      <Parameter Name="value"></Parameter>
      <Parameter Name="bValue">false</Parameter>
      <Parameter Name="helpText"></Parameter>
      <Parameter Name="horzOffset">0</Parameter>
      <Parameter Name="vertOffset">0</Parameter>
      <Parameter Name="alignGroup">0</Parameter>
      <Parameter Name="alignEdge">KRight</Parameter>
      <Parameter Name="alignMode">kResize</Parameter>
      <Parameter Name="visible">true</Parameter>
      <Parameter Name="enabled">true</Parameter>
      <Parameter Name="bindLeft">kNone</Parameter>
      <Parameter Name="bindRight">kNone</Parameter>
      <Parameter Name="bindTop">kNone</Parameter>
      <Parameter Name="bindBottom">kNone</Parameter>
      <Parameter Name="sizeToText">true</Parameter>
      <Parameter Name="ctrlWidth">16</Parameter>
      <Parameter Name="ctrlHeight">16</Parameter>
      <Parameter Name="ctrlLinesCnt">1</Parameter>
      <Parameter Name="realEditType">kEditRealType_RealNumber</Parameter>
      <Parameter Name="multiSelect">false</Parameter>
      <Parameter Name="margin">1</Parameter>
      <Parameter Name="renderMode">kWireframe</Parameter>
      <Parameter Name="viewMode">kTopPlan</Parameter>
      <Parameter Name="hasFrame">true</Parameter>
      <Parameter Name="ControlPoint00X">15,1</Parameter>
      <Parameter Name="ControlPoint00Y">-2,4</Parameter>
      <Parameter Name="ControlPoint01X">17</Parameter>
      <Parameter Name="ControlPoint01Y">-12</Parameter>
      <Parameter Name="ControlPoint02X">0</Parameter>
      <Parameter Name="ControlPoint02Y">0</Parameter>
      <Parameter Name="__RightUUID"></Parameter>
      <Parameter Name="__BottomUUID">%LB249B3E58-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="__savedHandleRightX">15,1</Parameter>
      <Parameter Name="__savedHandleRightY">-2,4</Parameter>
      <Parameter Name="__savedHandleBottomX">17</Parameter>
      <Parameter Name="__savedHandleBottomY">-12</Parameter>
      <Parameter Name="__arrAlignments"></Parameter>
      <Parameter Name="__fVisControlWidth">15,05851237</Parameter>
      <Parameter Name="__fVisControlHeight">4,86833333</Parameter>
    </Control>
    <Control name="DialogBuilderControl" x="-38.000000" y="54.000000">
      <Parameter Name="__UUID">%LB249B3E58-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="__locked">false</Parameter>
      <Parameter Name="type">kListBox</Parameter>
      <Parameter Name="id">5</Parameter>
      <Parameter Name="constName">ListBox1</Parameter>
      <Parameter Name="label"></Parameter>
      <Parameter Name="value"></Parameter>
      <Parameter Name="bValue">false</Parameter>
      <Parameter Name="helpText">This is list box control.</Parameter>
      <Parameter Name="horzOffset">0</Parameter>
      <Parameter Name="vertOffset">0</Parameter>
      <Parameter Name="alignGroup">0</Parameter>
      <Parameter Name="alignEdge">KRight</Parameter>
      <Parameter Name="alignMode">kResize</Parameter>
      <Parameter Name="visible">true</Parameter>
      <Parameter Name="enabled">true</Parameter>
      <Parameter Name="bindLeft">kFixed</Parameter>
      <Parameter Name="bindRight">kProp</Parameter>
      <Parameter Name="bindTop">kNone</Parameter>
      <Parameter Name="bindBottom">kNone</Parameter>
      <Parameter Name="sizeToText">true</Parameter>
      <Parameter Name="ctrlWidth">25</Parameter>
      <Parameter Name="ctrlHeight">16</Parameter>
      <Parameter Name="ctrlLinesCnt">10</Parameter>
      <Parameter Name="realEditType">kEditRealType_RealNumber</Parameter>
      <Parameter Name="multiSelect">false</Parameter>
      <Parameter Name="margin">1</Parameter>
      <Parameter Name="renderMode">kWireframe</Parameter>
      <Parameter Name="viewMode">kTopPlan</Parameter>
      <Parameter Name="hasFrame">true</Parameter>
      <Parameter Name="ControlPoint00X">55</Parameter>
      <Parameter Name="ControlPoint00Y">-13,2</Parameter>
      <Parameter Name="ControlPoint01X">11,6</Parameter>
      <Parameter Name="ControlPoint01Y">-46</Parameter>
      <Parameter Name="ControlPoint02X">0</Parameter>
      <Parameter Name="ControlPoint02Y">0</Parameter>
      <Parameter Name="__RightUUID">%LB7A6FE658-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="__BottomUUID">%LB249B3E59-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="__savedHandleRightX">55</Parameter>
      <Parameter Name="__savedHandleRightY">-13,2</Parameter>
      <Parameter Name="__savedHandleBottomX">11,6</Parameter>
      <Parameter Name="__savedHandleBottomY">-46</Parameter>
      <Parameter Name="__arrAlignments"></Parameter>
      <Parameter Name="__fVisControlWidth">31,99804687</Parameter>
      <Parameter Name="__fVisControlHeight">24,34166667</Parameter>
    </Control>
    <Control name="DialogBuilderControl" x="-38.000000" y="8.000000">
      <Parameter Name="__UUID">%LB249B3E59-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="__locked">false</Parameter>
      <Parameter Name="type">kStaticText</Parameter>
      <Parameter Name="id">6</Parameter>
      <Parameter Name="constName">ListBrowserText</Parameter>
      <Parameter Name="label">List Browser</Parameter>
      <Parameter Name="value"></Parameter>
      <Parameter Name="bValue">false</Parameter>
      <Parameter Name="helpText"></Parameter>
      <Parameter Name="horzOffset">0</Parameter>
      <Parameter Name="vertOffset">0</Parameter>
      <Parameter Name="alignGroup">0</Parameter>
      <Parameter Name="alignEdge">KRight</Parameter>
      <Parameter Name="alignMode">kResize</Parameter>
      <Parameter Name="visible">true</Parameter>
      <Parameter Name="enabled">true</Parameter>
      <Parameter Name="bindLeft">kNone</Parameter>
      <Parameter Name="bindRight">kNone</Parameter>
      <Parameter Name="bindTop">kNone</Parameter>
      <Parameter Name="bindBottom">kNone</Parameter>
      <Parameter Name="sizeToText">true</Parameter>
      <Parameter Name="ctrlWidth">16</Parameter>
      <Parameter Name="ctrlHeight">16</Parameter>
      <Parameter Name="ctrlLinesCnt">1</Parameter>
      <Parameter Name="realEditType">kEditRealType_RealNumber</Parameter>
      <Parameter Name="multiSelect">false</Parameter>
      <Parameter Name="margin">1</Parameter>
      <Parameter Name="renderMode">kWireframe</Parameter>
      <Parameter Name="viewMode">kTopPlan</Parameter>
      <Parameter Name="hasFrame">true</Parameter>
      <Parameter Name="ControlPoint00X">23,3</Parameter>
      <Parameter Name="ControlPoint00Y">-2,4</Parameter>
      <Parameter Name="ControlPoint01X">24,2</Parameter>
      <Parameter Name="ControlPoint01Y">-12</Parameter>
      <Parameter Name="ControlPoint02X">0</Parameter>
      <Parameter Name="ControlPoint02Y">0</Parameter>
      <Parameter Name="__RightUUID"></Parameter>
      <Parameter Name="__BottomUUID">%LB249B3E5A-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="__savedHandleRightX">23,3</Parameter>
      <Parameter Name="__savedHandleRightY">-2,4</Parameter>
      <Parameter Name="__savedHandleBottomX">24,2</Parameter>
      <Parameter Name="__savedHandleBottomY">-12</Parameter>
      <Parameter Name="__arrAlignments"></Parameter>
      <Parameter Name="__fVisControlWidth">23,28953451</Parameter>
      <Parameter Name="__fVisControlHeight">4,86833333</Parameter>
    </Control>
    <Control name="DialogBuilderControl" x="-38.000000" y="-4.000000">
      <Parameter Name="__UUID">%LB249B3E5A-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="__locked">false</Parameter>
      <Parameter Name="type">kListBrowser</Parameter>
      <Parameter Name="id">7</Parameter>
      <Parameter Name="constName">ListBrowser</Parameter>
      <Parameter Name="label"></Parameter>
      <Parameter Name="value"></Parameter>
      <Parameter Name="bValue">false</Parameter>
      <Parameter Name="helpText">This is list browser control.</Parameter>
      <Parameter Name="horzOffset">0</Parameter>
      <Parameter Name="vertOffset">0</Parameter>
      <Parameter Name="alignGroup">1</Parameter>
      <Parameter Name="alignEdge">KRight</Parameter>
      <Parameter Name="alignMode">kResize</Parameter>
      <Parameter Name="visible">true</Parameter>
      <Parameter Name="enabled">true</Parameter>
      <Parameter Name="bindLeft">kNone</Parameter>
      <Parameter Name="bindRight">kNone</Parameter>
      <Parameter Name="bindTop">kNone</Parameter>
      <Parameter Name="bindBottom">kNone</Parameter>
      <Parameter Name="sizeToText">true</Parameter>
      <Parameter Name="ctrlWidth">50</Parameter>
      <Parameter Name="ctrlHeight">16</Parameter>
      <Parameter Name="ctrlLinesCnt">10</Parameter>
      <Parameter Name="realEditType">kEditRealType_RealNumber</Parameter>
      <Parameter Name="multiSelect">false</Parameter>
      <Parameter Name="margin">1</Parameter>
      <Parameter Name="renderMode">kWireframe</Parameter>
      <Parameter Name="viewMode">kTopPlan</Parameter>
      <Parameter Name="hasFrame">true</Parameter>
      <Parameter Name="ControlPoint00X">48,5</Parameter>
      <Parameter Name="ControlPoint00Y">-12,2</Parameter>
      <Parameter Name="ControlPoint01X">24,2</Parameter>
      <Parameter Name="ControlPoint01Y">-24,3</Parameter>
      <Parameter Name="ControlPoint02X">0</Parameter>
      <Parameter Name="ControlPoint02Y">0</Parameter>
      <Parameter Name="__RightUUID"></Parameter>
      <Parameter Name="__BottomUUID"></Parameter>
      <Parameter Name="__savedHandleRightX">48,5</Parameter>
      <Parameter Name="__savedHandleRightY">-12,2</Parameter>
      <Parameter Name="__savedHandleBottomX">24,2</Parameter>
      <Parameter Name="__savedHandleBottomY">-24,3</Parameter>
      <Parameter Name="__arrAlignments"></Parameter>
      <Parameter Name="__fVisControlWidth">48,46009115</Parameter>
      <Parameter Name="__fVisControlHeight">24,34166667</Parameter>
    </Control>
    <Control name="Dialog Builder Link" x="0.000000" y="0.000000">
      <Parameter Name="ParentObj">%LBFFA206A4-E03B-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="RelatedObj">%LB249B3E58-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="ParentMode">1</Parameter>
    </Control>
    <Control name="Dialog Builder Link" x="0.000000" y="0.000000">
      <Parameter Name="ParentObj">%LB249B3E58-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="RelatedObj">%LB249B3E59-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="ParentMode">1</Parameter>
    </Control>
    <Control name="Dialog Builder Link" x="0.000000" y="0.000000">
      <Parameter Name="ParentObj">%LB249B3E59-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="RelatedObj">%LB249B3E5A-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="ParentMode">1</Parameter>
    </Control>
    <Control name="DialogBuilderControl" x="17.000000" y="53.000000">
      <Parameter Name="__UUID">%LB7A6FE658-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="__locked">false</Parameter>
      <Parameter Name="type">kListBox</Parameter>
      <Parameter Name="id">8</Parameter>
      <Parameter Name="constName">ListBox2</Parameter>
      <Parameter Name="label"></Parameter>
      <Parameter Name="value"></Parameter>
      <Parameter Name="bValue">false</Parameter>
      <Parameter Name="helpText">Tabbed content list box. This list box contains rows with two strings with tab delimiter. This causes the list to have two columns.</Parameter>
      <Parameter Name="horzOffset">0</Parameter>
      <Parameter Name="vertOffset">0</Parameter>
      <Parameter Name="alignGroup">1</Parameter>
      <Parameter Name="alignEdge">KRight</Parameter>
      <Parameter Name="alignMode">kResize</Parameter>
      <Parameter Name="visible">true</Parameter>
      <Parameter Name="enabled">true</Parameter>
      <Parameter Name="bindLeft">kProp</Parameter>
      <Parameter Name="bindRight">kFixed</Parameter>
      <Parameter Name="bindTop">kNone</Parameter>
      <Parameter Name="bindBottom">kNone</Parameter>
      <Parameter Name="sizeToText">true</Parameter>
      <Parameter Name="ctrlWidth">25</Parameter>
      <Parameter Name="ctrlHeight">16</Parameter>
      <Parameter Name="ctrlLinesCnt">10</Parameter>
      <Parameter Name="realEditType">kEditRealType_RealNumber</Parameter>
      <Parameter Name="multiSelect">false</Parameter>
      <Parameter Name="margin">1</Parameter>
      <Parameter Name="renderMode">kWireframe</Parameter>
      <Parameter Name="viewMode">kTopPlan</Parameter>
      <Parameter Name="hasFrame">true</Parameter>
      <Parameter Name="ControlPoint00X">32</Parameter>
      <Parameter Name="ControlPoint00Y">-12,2</Parameter>
      <Parameter Name="ControlPoint01X">16</Parameter>
      <Parameter Name="ControlPoint01Y">-24,3</Parameter>
      <Parameter Name="ControlPoint02X">0</Parameter>
      <Parameter Name="ControlPoint02Y">0</Parameter>
      <Parameter Name="__RightUUID"></Parameter>
      <Parameter Name="__BottomUUID"></Parameter>
      <Parameter Name="__savedHandleRightX">32</Parameter>
      <Parameter Name="__savedHandleRightY">-12,2</Parameter>
      <Parameter Name="__savedHandleBottomX">16</Parameter>
      <Parameter Name="__savedHandleBottomY">-24,3</Parameter>
      <Parameter Name="__arrAlignments"></Parameter>
      <Parameter Name="__fVisControlWidth">31,99804687</Parameter>
      <Parameter Name="__fVisControlHeight">24,34166667</Parameter>
    </Control>
    <Control name="Dialog Builder Link" x="0.000000" y="0.000000">
      <Parameter Name="ParentObj">%LB249B3E58-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="RelatedObj">%LB7A6FE658-E03C-11DB-B912-00138FD51EA3%RB</Parameter>
      <Parameter Name="ParentMode">0</Parameter>
    </Control>
  </Controls>

</DialogBuilder>

<END_XML>}

