//
//	ModuleMain.cpp
//
//	Main entry point for Vectorworks module code.
//

#include "StdAfx.h"
#include "UI/ExtMenuClassName.h"

//------------------------------------------------------------------
// Entry point of the module plug-in for Vectorworks
// More info at: http://developer.vectorworks.net/index.php?title=SDK:Module_Plug-in
//
extern "C" long GS_EXTERNAL_ENTRY plugin_main(long action, void* pInfo, long& ioData, CallBackPtr cbp)
{
	// initialize VCOM mechanizm
	::GS_InitializeVCOM( cbp );

	// init legacy Global Callback Pointer
	// for support of legacy GS_ functions
	gCBP	= cbp;

	{ // Init gSDK
		using namespace VectorWorks;
		VCOMPtr<ISDK>	localSDK( IID_SDK );
		gSDK	= localSDK;
	}

	long	reply	= 0L;

	using namespace VWFC::PluginSupport;

	REGISTER_Extension<UI::CExtMenuClassName>( GROUPID_ExtensionMenu, action, pInfo, ioData, cbp, reply );

	return reply;
}
